#include <iostream>
#include <string>
#include <map>

using namespace std;

typedef map<string, string> stringMap;

static stringMap *list = new stringMap();

int remove_entry(stringMap *list, string name)
{
    stringMap::iterator itr = list->find(name);

    if (itr != list->end())
    {
        list->erase(name);
        return 1;
    }

    return -1;
}

void add_entry(stringMap *list, string name, string email)
{
    stringMap::iterator itr = list->find(name);

    if (itr != list->end())
    {
        remove_entry(list, name);
    }
    list->insert( pair<string,string>(name, email) );
}

void list_entries(stringMap *list)
{
    stringMap::iterator itr = list->begin(),
        end = list->end();

    for(; itr != end; ++itr)
    {
        cout << itr->first << " --> " << itr->second << endl;
    }
}

int main()
{
    while(1)
    {
        char cmd;
        int rc = 0;
        string email = "";
        string name = "";
        string orig_name = "";

        cout << "Enter a command (l: list, d: delete, a: add, e: edit)" << endl;
        cout << "Any other input will quit." << endl;
        cout << "Command: ";
        cin >> cmd;
        cin.get(); // Eat the newline that does weird things!

        switch(cmd)
        {
            case 'l':
                list_entries(list);
            continue;

            case 'd':
                cout << "Whose entry do you wish to delete? ";
                getline(cin, name, '\n');
                rc = remove_entry(list, name);

                if (rc == 1)
                {
                    cout << name << " was removed from the list." << endl;
                }
                else
                {
                    cout << name << " is not in the list. Moving on..." << endl;
                }
            continue;

            case 'e':
                cout << "Whose entry do you wish to edit? ";
                getline(cin, orig_name, '\n');
                remove_entry(list, orig_name);

                cout << "What should their name be? ";
                getline(cin, name, '\n');

                cout << "What should their email address be? ";
                getline(cin, email, '\n');

                add_entry(list, name, email);

                cout << "Updated " << orig_name << "'s entry." << endl;
            continue;

            case 'a':
                cout << "What is their name? ";
                getline(cin, name, '\n');

                cout << "What is their email address? ";
                getline(cin, email, '\n');

                add_entry(list, name, email);

                cout << name << ", with email address " << email << ", was added to the list." << endl;
            continue;

            default:
                cout << "Exiting..." << endl;
                goto cleanup;
            continue;
        }
    }
cleanup:
    delete list;
    return 0;
}
